map = {}
map.map = {}
map.def = {}
map.spawns = {}

map.def["#"] = {true, {100,100,100}, function(x,y) print(map.map[y][x][1]) return true end}
map.def["."] = {false, {25,25,25}}
map.def["G"] = {false, {25,75,25}}
map.def["\r"] = {true, {0,0,0}}
map.def["\n"] = {true, {0,0,0}}
map.def["w"] = {true, {75, 50, 25}, function(x,y) map.map[y][x].solid = not map.map[y][x].solid end}
map.def[" "] = {true, {0,0,0}}
map.def["d"] = {true, {25,25,25}}
map.def["o"] = {false, {40,40,150}} -- spawnzone


function explode(str, div)
    assert(type(str) == "string" and type(div) == "string", "invalid arguments")
    local o = {}
    while true do
        local pos1,pos2 = str:find(div)
        if not pos1 then
            o[#o+1] = str
            break
        end
        o[#o+1],str = str:sub(1,pos1-1),str:sub(pos2+1)
    end
    return o
end

function map.load(name)
  if love.filesystem.exists(name) then
    local txtmap = love.filesystem.read(name)
    local arrmap = explode(txtmap,"\n")
    for i=1, #arrmap do
      map.map[i] = {}
      for j=1, #arrmap[i] do
        local char = string.sub(arrmap[i],j,j)
        if char == "o" then map.spawns[#map.spawns+1] = {j, i} end -- spawn
        map.map[i][j] = {
          solid = map.def[char][1] or false,
          color = map.def[char][2] or {255,0,255},
          func = map.def[char][3] or nil,
          x = 0,
          y = 0,
          char = char,
        }
      end
    end

    return map.map
  end

end

function map.draw()
  for i=1, #map.map do
    for j=1, #map.map[i] do
      local tile = map.map[i][j]
      tile.x = j*game.TILESIZE*game.TILESCALE
      tile.y = i*game.TILESIZE*game.TILESCALE
      love.graphics.setColor(tile.color)
      love.graphics.rectangle("fill", tile.x, tile.y, game.TILESIZE*game.TILESCALE, game.TILESIZE*game.TILESCALE)
      if game.DEBUG then
        love.graphics.setColor(255,255,255,100)
        love.graphics.print(j..", "..i,tile.x,tile.y)
        love.graphics.print(tile.char,tile.x,tile.y+15)
      end
    end
  end
end

function map.getTileOnXY(x,y)
  return map.map[y][x]
end

function map.convertCordAbs(c)
  return math.floor( c / (game.TILESIZE*game.TILESCALE) )
end

function map.convertCordTile(c)
  return c * game.TILESIZE*game.TILESCALE
end

function map.getTileOnAbsXY(x,y)
  return map.map[math.floor(y/(game.TILESIZE*game.TILESCALE))][math.floor(y/(game.TILESIZE*game.TILESCALE))]
end
