math.randomseed(os.time()/1000)

function love.load()
  game = {
    width = love.window.getWidth(),
    height = love.window.getHeight(),
    TILESIZE = 10,
    TILESCALE = 5,
    ENTITYSCALE = 0.7,
    NAME = "lemonjuice",
    DEBUG = false,
  }
  require "dll/map"
  require "dll/entity"
  local font = love.graphics.newFont("rs.ttf",12)
  font:setFilter("nearest")
  love.graphics.setFont(font)
  map.load("maps/map.txt")
  ply = entity.new("player", "player", {200,200,25})
  entity.spawn(ply)
end

function love.update(dt)
  entity.update(dt)
end

function love.draw()
  love.graphics.push()
  love.graphics.translate(-ply.x+game.width/2,-ply.y+game.height/2)
  map.draw()
  entity.draw()
  love.graphics.pop()
  love.graphics.setColor(255,255,255)
  love.graphics.print(love.timer.getFPS().." FPS "..math.floor(collectgarbage("count")).." KB", 10, 10)
end

function love.keypressed(key)
  entity.key(key)
  if key == "f11" then
    game.DEBUG = not game.DEBUG
  end
  if key == "f12" then
    local screenie = love.graphics.newScreenshot()
    screenie:encode(os.time()..".png")
    print("Screenie taken! "..os.time()..".png")
  end
end
